import { LogAbstract } from './log';
import { App } from './app';
export interface RuntimeModule {
    module: Module;
    options: any;
}
export interface ModuleMeta {
    name: string;
    defaultConfig: any;
}
export declare abstract class Module {
    app: App;
    log: LogAbstract;
    meta: ModuleMeta;
    config: any;
    options: any;
    private _name;
    constructor(app: App, options?: any);
    name: string;
    setConfig(ns: string, dConfig?: any): any;
    prepareConfig(ns?: string, dConfig?: any): any;
    insert(ns: string, currentModule: any): void;
    setup(): Promise<void>;
    teardown(): Promise<any>;
}
